#include "mainwindow.h"
#include "ui_mainwindow.h"


MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QString content;
    QString fileName = ":/index.html";
    QFile file(fileName);

    if( file.open(QFile::ReadOnly) ){
        content = QString(file.readAll());
    }else{
        QMessageBox::information(this, tr("GPS Mapper"),
                                      tr("Cannot load %1.").arg(fileName));
        qFatal("Error opening index html file.");
    }
    file.close();

    QWebView *frame;

    frame = ui->webView;
    frame->page()->mainFrame()->setScrollBarPolicy(Qt::Vertical, Qt::ScrollBarAlwaysOff);
    frame->page()->mainFrame()->setScrollBarPolicy(Qt::Horizontal, Qt::ScrollBarAlwaysOff);
    frame->setHtml(content);

    myObject = new JavascriptObject(this);
    frame->page()->mainFrame()->addToJavaScriptWindowObject("myObject",myObject);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_PutMarker_clicked()
{
    QString marker = QString("markers(%1,%2,'You clicked me'); null")
            .arg(myObject->getLatLng().rx())
            .arg(myObject->getLatLng().ry());

    ui->webView->page()->mainFrame()->evaluateJavaScript(marker);
}

void MainWindow::on_ClearMarker_clicked()
{
    QString marker = "removemarkers(); null";
    ui->webView->page()->mainFrame()->evaluateJavaScript(marker);
}

void MainWindow::javascriptClick(void){
    ui->lat->setText(QString::number(myObject->getLatLng().rx()));
    ui->lng->setText(QString::number(myObject->getLatLng().ry()));
}
